var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { g as getAugmentedNamespace, j as jwtDecode_esm, a as getDefaultExportFromCjs, c as commonjsGlobal, o as objectType, b as custom, s as stringType, f as functionType, v as voidType, u as unionType, n as nullType, d as unknownType, e as nativeEnumType, h as optionsSchema$3, i as getConfigResponseSchema, k as configSchema, l as o, m as getUserResponseSchema, p as userSchema, q as getViewInputSchema, r as getViewResponseSchema, t as askInputSchema, w as askResponseSchema, x as actionNotificationInputSchema, y as actionNotificationResponseSchema } from "./index-8c15eae1.js";
var lib = { exports: {} };
const require$$0 = /* @__PURE__ */ getAugmentedNamespace(jwtDecode_esm);
(function(module, exports) {
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || function(mod) {
    return mod && mod.__esModule ? mod : { "default": mod };
  };
  Object.defineProperty(exports, "__esModule", { value: true });
  const jwt_decode_1 = __importDefault(require$$0);
  function jwtCache2({ getToken, eagerRefreshMilliseconds = 0, minimumValidityMilliseconds = 1e3 }) {
    let disposed = false;
    let statePromise;
    let nextState;
    let timeout2;
    const getState = async () => {
      const token = await getToken();
      const decoded = jwt_decode_1.default(token);
      if (typeof decoded === "object" && decoded !== null && typeof decoded.exp === "number") {
        const expiry = decoded.exp * 1e3;
        return { token, expiry };
      } else {
        throw new Error(`You can only cache a JWT if it has an "exp" that is an integer number of seconds`);
      }
    };
    const handleEagerRefresh = (state, currentStatePromise) => {
      if (disposed)
        return;
      if (eagerRefreshMilliseconds) {
        timeout2 = setTimeout(() => {
          if (statePromise === currentStatePromise) {
            const thisNextState = nextState = getState();
            thisNextState.then((state2) => {
              if (nextState === thisNextState && statePromise === currentStatePromise) {
                statePromise = thisNextState;
                handleEagerRefresh(state2, thisNextState);
              }
            }, (_ex) => {
              if (nextState === thisNextState && statePromise === currentStatePromise) {
                nextState = void 0;
              }
            });
          }
        }, state.expiry - Date.now() - minimumValidityMilliseconds - eagerRefreshMilliseconds);
      }
    };
    const getUpdatedToken = async (currentStatePromise) => {
      if (statePromise && currentStatePromise !== statePromise) {
        return (await statePromise).token;
      }
      statePromise = nextState !== null && nextState !== void 0 ? nextState : getState();
      nextState = void 0;
      try {
        const state = await statePromise;
        handleEagerRefresh(state, statePromise);
        return state.token;
      } catch (ex) {
        statePromise = void 0;
        throw ex;
      }
    };
    if (eagerRefreshMilliseconds) {
      getUpdatedToken(void 0).catch(() => {
      });
    }
    return {
      dispose: () => {
        disposed = true;
        if (timeout2) {
          clearTimeout(timeout2);
        }
      },
      getToken: async () => {
        if (disposed) {
          throw new Error(`Cannot get token after disposing jwt-cache`);
        }
        const stateP = statePromise;
        if (!stateP) {
          return await getUpdatedToken(stateP);
        }
        const state = await stateP;
        if (state.expiry - Date.now() >= minimumValidityMilliseconds) {
          return state.token;
        }
        return await getUpdatedToken(stateP);
      }
    };
  }
  exports.default = jwtCache2;
  module.exports = Object.assign(jwtCache2, { default: jwtCache2 });
})(lib, lib.exports);
var libExports = lib.exports;
const jwtCache = /* @__PURE__ */ getDefaultExportFromCjs(libExports);
const copyProperty = (to, from, property, ignoreNonConfigurable) => {
  if (property === "length" || property === "prototype") {
    return;
  }
  if (property === "arguments" || property === "caller") {
    return;
  }
  const toDescriptor = Object.getOwnPropertyDescriptor(to, property);
  const fromDescriptor = Object.getOwnPropertyDescriptor(from, property);
  if (!canCopyProperty(toDescriptor, fromDescriptor) && ignoreNonConfigurable) {
    return;
  }
  Object.defineProperty(to, property, fromDescriptor);
};
const canCopyProperty = function(toDescriptor, fromDescriptor) {
  return toDescriptor === void 0 || toDescriptor.configurable || toDescriptor.writable === fromDescriptor.writable && toDescriptor.enumerable === fromDescriptor.enumerable && toDescriptor.configurable === fromDescriptor.configurable && (toDescriptor.writable || toDescriptor.value === fromDescriptor.value);
};
const changePrototype = (to, from) => {
  const fromPrototype = Object.getPrototypeOf(from);
  if (fromPrototype === Object.getPrototypeOf(to)) {
    return;
  }
  Object.setPrototypeOf(to, fromPrototype);
};
const wrappedToString = (withName, fromBody) => `/* Wrapped ${withName}*/
${fromBody}`;
const toStringDescriptor = Object.getOwnPropertyDescriptor(Function.prototype, "toString");
const toStringName = Object.getOwnPropertyDescriptor(Function.prototype.toString, "name");
const changeToString = (to, from, name) => {
  const withName = name === "" ? "" : `with ${name.trim()}() `;
  const newToString = wrappedToString.bind(null, withName, from.toString());
  Object.defineProperty(newToString, "name", toStringName);
  Object.defineProperty(to, "toString", { ...toStringDescriptor, value: newToString });
};
function mimicFunction(to, from, { ignoreNonConfigurable = false } = {}) {
  const { name } = to;
  for (const property of Reflect.ownKeys(from)) {
    copyProperty(to, from, property, ignoreNonConfigurable);
  }
  changePrototype(to, from);
  changeToString(to, from, name);
  return to;
}
const cacheStore = /* @__PURE__ */ new WeakMap();
function pMemoize(fn, { cacheKey = ([firstArgument]) => firstArgument, cache = /* @__PURE__ */ new Map() } = {}) {
  const promiseCache = /* @__PURE__ */ new Map();
  const memoized = function(...arguments_) {
    const key = cacheKey(arguments_);
    if (promiseCache.has(key)) {
      return promiseCache.get(key);
    }
    const promise = (async () => {
      try {
        if (cache && await cache.has(key)) {
          return await cache.get(key);
        }
        const promise2 = fn.apply(this, arguments_);
        const result = await promise2;
        try {
          return result;
        } finally {
          if (cache) {
            await cache.set(key, result);
          }
        }
      } finally {
        promiseCache.delete(key);
      }
    })();
    promiseCache.set(key, promise);
    return promise;
  };
  mimicFunction(memoized, fn, {
    ignoreNonConfigurable: true
  });
  cacheStore.set(memoized, cache);
  return memoized;
}
function toS(obj) {
  return Object.prototype.toString.call(obj);
}
function isDate(obj) {
  return toS(obj) === "[object Date]";
}
function isRegExp(obj) {
  return toS(obj) === "[object RegExp]";
}
function isError(obj) {
  return toS(obj) === "[object Error]";
}
function isBoolean(obj) {
  return toS(obj) === "[object Boolean]";
}
function isNumber(obj) {
  return toS(obj) === "[object Number]";
}
function isString(obj) {
  return toS(obj) === "[object String]";
}
var isArray = Array.isArray || function isArray2(xs) {
  return Object.prototype.toString.call(xs) === "[object Array]";
};
function forEach(xs, fn) {
  if (xs.forEach) {
    return xs.forEach(fn);
  }
  for (var i = 0; i < xs.length; i++) {
    fn(xs[i], i, xs);
  }
  return void 0;
}
var objectKeys = Object.keys || function keys(obj) {
  var res = [];
  for (var key in obj) {
    res.push(key);
  }
  return res;
};
var hasOwnProperty = Object.prototype.hasOwnProperty || function(obj, key) {
  return key in obj;
};
function copy(src) {
  if (typeof src === "object" && src !== null) {
    var dst;
    if (isArray(src)) {
      dst = [];
    } else if (isDate(src)) {
      dst = new Date(src.getTime ? src.getTime() : src);
    } else if (isRegExp(src)) {
      dst = new RegExp(src);
    } else if (isError(src)) {
      dst = { message: src.message };
    } else if (isBoolean(src) || isNumber(src) || isString(src)) {
      dst = Object(src);
    } else if (Object.create && Object.getPrototypeOf) {
      dst = Object.create(Object.getPrototypeOf(src));
    } else if (src.constructor === Object) {
      dst = {};
    } else {
      var proto2 = src.constructor && src.constructor.prototype || src.__proto__ || {};
      var T = function T2() {
      };
      T.prototype = proto2;
      dst = new T();
    }
    forEach(objectKeys(src), function(key) {
      dst[key] = src[key];
    });
    return dst;
  }
  return src;
}
function walk(root, cb, immutable) {
  var path = [];
  var parents = [];
  var alive = true;
  return function walker(node_) {
    var node = immutable ? copy(node_) : node_;
    var modifiers = {};
    var keepGoing = true;
    var state = {
      node,
      node_,
      path: [].concat(path),
      parent: parents[parents.length - 1],
      parents,
      key: path[path.length - 1],
      isRoot: path.length === 0,
      level: path.length,
      circular: null,
      update: function(x, stopHere) {
        if (!state.isRoot) {
          state.parent.node[state.key] = x;
        }
        state.node = x;
        if (stopHere) {
          keepGoing = false;
        }
      },
      delete: function(stopHere) {
        delete state.parent.node[state.key];
        if (stopHere) {
          keepGoing = false;
        }
      },
      remove: function(stopHere) {
        if (isArray(state.parent.node)) {
          state.parent.node.splice(state.key, 1);
        } else {
          delete state.parent.node[state.key];
        }
        if (stopHere) {
          keepGoing = false;
        }
      },
      keys: null,
      before: function(f) {
        modifiers.before = f;
      },
      after: function(f) {
        modifiers.after = f;
      },
      pre: function(f) {
        modifiers.pre = f;
      },
      post: function(f) {
        modifiers.post = f;
      },
      stop: function() {
        alive = false;
      },
      block: function() {
        keepGoing = false;
      }
    };
    if (!alive) {
      return state;
    }
    function updateState() {
      if (typeof state.node === "object" && state.node !== null) {
        if (!state.keys || state.node_ !== state.node) {
          state.keys = objectKeys(state.node);
        }
        state.isLeaf = state.keys.length === 0;
        for (var i = 0; i < parents.length; i++) {
          if (parents[i].node_ === node_) {
            state.circular = parents[i];
            break;
          }
        }
      } else {
        state.isLeaf = true;
        state.keys = null;
      }
      state.notLeaf = !state.isLeaf;
      state.notRoot = !state.isRoot;
    }
    updateState();
    var ret = cb.call(state, state.node);
    if (ret !== void 0 && state.update) {
      state.update(ret);
    }
    if (modifiers.before) {
      modifiers.before.call(state, state.node);
    }
    if (!keepGoing) {
      return state;
    }
    if (typeof state.node === "object" && state.node !== null && !state.circular) {
      parents.push(state);
      updateState();
      forEach(state.keys, function(key, i) {
        path.push(key);
        if (modifiers.pre) {
          modifiers.pre.call(state, state.node[key], key);
        }
        var child = walker(state.node[key]);
        if (immutable && hasOwnProperty.call(state.node, key)) {
          state.node[key] = child.node;
        }
        child.isLast = i === state.keys.length - 1;
        child.isFirst = i === 0;
        if (modifiers.post) {
          modifiers.post.call(state, child);
        }
        path.pop();
      });
      parents.pop();
    }
    if (modifiers.after) {
      modifiers.after.call(state, state.node);
    }
    return state;
  }(root).node;
}
function Traverse(obj) {
  this.value = obj;
}
Traverse.prototype.get = function(ps) {
  var node = this.value;
  for (var i = 0; i < ps.length; i++) {
    var key = ps[i];
    if (!node || !hasOwnProperty.call(node, key)) {
      return void 0;
    }
    node = node[key];
  }
  return node;
};
Traverse.prototype.has = function(ps) {
  var node = this.value;
  for (var i = 0; i < ps.length; i++) {
    var key = ps[i];
    if (!node || !hasOwnProperty.call(node, key)) {
      return false;
    }
    node = node[key];
  }
  return true;
};
Traverse.prototype.set = function(ps, value) {
  var node = this.value;
  for (var i = 0; i < ps.length - 1; i++) {
    var key = ps[i];
    if (!hasOwnProperty.call(node, key)) {
      node[key] = {};
    }
    node = node[key];
  }
  node[ps[i]] = value;
  return value;
};
Traverse.prototype.map = function(cb) {
  return walk(this.value, cb, true);
};
Traverse.prototype.forEach = function(cb) {
  this.value = walk(this.value, cb, false);
  return this.value;
};
Traverse.prototype.reduce = function(cb, init) {
  var skip = arguments.length === 1;
  var acc = skip ? this.value : init;
  this.forEach(function(x) {
    if (!this.isRoot || !skip) {
      acc = cb.call(this, acc, x);
    }
  });
  return acc;
};
Traverse.prototype.paths = function() {
  var acc = [];
  this.forEach(function() {
    acc.push(this.path);
  });
  return acc;
};
Traverse.prototype.nodes = function() {
  var acc = [];
  this.forEach(function() {
    acc.push(this.node);
  });
  return acc;
};
Traverse.prototype.clone = function() {
  var parents = [];
  var nodes = [];
  return function clone(src) {
    for (var i = 0; i < parents.length; i++) {
      if (parents[i] === src) {
        return nodes[i];
      }
    }
    if (typeof src === "object" && src !== null) {
      var dst = copy(src);
      parents.push(src);
      nodes.push(dst);
      forEach(objectKeys(src), function(key) {
        dst[key] = clone(src[key]);
      });
      parents.pop();
      nodes.pop();
      return dst;
    }
    return src;
  }(this.value);
};
function traverse(obj) {
  return new Traverse(obj);
}
forEach(objectKeys(Traverse.prototype), function(key) {
  traverse[key] = function(obj) {
    var args = [].slice.call(arguments, 1);
    var t = new Traverse(obj);
    return t[key].apply(t, args);
  };
});
var traverse_1 = traverse;
const traverse$1 = /* @__PURE__ */ getDefaultExportFromCjs(traverse_1);
const optionsSchema$2 = objectType({
  core: custom(),
  prefix: stringType().default("workgrid"),
  storage: objectType({
    setItem: functionType().args(stringType(), stringType()).returns(voidType()),
    getItem: functionType().args(stringType()).returns(unionType([stringType(), nullType()]))
  }).default(() => ({
    setItem: (key, value) => localStorage.setItem(key, value),
    getItem: (key) => localStorage.getItem(key)
  })),
  serializer: objectType({
    serialize: functionType().args(unknownType()).returns(stringType()),
    deserialize: functionType().args(stringType()).returns(unknownType())
  }).default(() => ({
    serialize: (value) => JSON.stringify(value),
    deserialize: (value) => JSON.parse(value)
  }))
});
class Cache {
  constructor(options) {
    __publicField(this, "options");
    __publicField(this, "core");
    __publicField(this, "logger");
    __publicField(this, "prefix");
    __publicField(this, "storage");
    __publicField(this, "serializer");
    this.options = optionsSchema$2.parse(options);
    this.core = this.options.core;
    this.logger = this.options.core.logger.extend({ prefix: "core/cache" });
    this.prefix = this.options.prefix;
    this.storage = this.options.storage;
    this.serializer = this.options.serializer;
    this.get = this.logger.wrapFn(this.get.bind(this));
    this.set = this.logger.wrapFn(this.set.bind(this));
  }
  get(key) {
    try {
      const serialized = this.storage.getItem(`${this.prefix}:${key}`);
      return serialized && this.serializer.deserialize(serialized);
    } catch (error) {
      this.logger.error("Cache unable to get", key, error);
    }
  }
  set(key, value) {
    try {
      const serialized = this.serializer.serialize(value);
      this.storage.setItem(`${this.prefix}:${key}`, serialized);
    } catch (error) {
      this.logger.error("Cache unsable to set", key, value, error);
    }
  }
}
const ANSI_BACKGROUND_OFFSET = 10;
const wrapAnsi16 = (offset = 0) => (code) => `\x1B[${code + offset}m`;
const wrapAnsi256 = (offset = 0) => (code) => `\x1B[${38 + offset};5;${code}m`;
const wrapAnsi16m = (offset = 0) => (red, green, blue) => `\x1B[${38 + offset};2;${red};${green};${blue}m`;
const styles$1 = {
  modifier: {
    reset: [0, 0],
    // 21 isn't widely supported and 22 does the same thing
    bold: [1, 22],
    dim: [2, 22],
    italic: [3, 23],
    underline: [4, 24],
    overline: [53, 55],
    inverse: [7, 27],
    hidden: [8, 28],
    strikethrough: [9, 29]
  },
  color: {
    black: [30, 39],
    red: [31, 39],
    green: [32, 39],
    yellow: [33, 39],
    blue: [34, 39],
    magenta: [35, 39],
    cyan: [36, 39],
    white: [37, 39],
    // Bright color
    blackBright: [90, 39],
    gray: [90, 39],
    // Alias of `blackBright`
    grey: [90, 39],
    // Alias of `blackBright`
    redBright: [91, 39],
    greenBright: [92, 39],
    yellowBright: [93, 39],
    blueBright: [94, 39],
    magentaBright: [95, 39],
    cyanBright: [96, 39],
    whiteBright: [97, 39]
  },
  bgColor: {
    bgBlack: [40, 49],
    bgRed: [41, 49],
    bgGreen: [42, 49],
    bgYellow: [43, 49],
    bgBlue: [44, 49],
    bgMagenta: [45, 49],
    bgCyan: [46, 49],
    bgWhite: [47, 49],
    // Bright color
    bgBlackBright: [100, 49],
    bgGray: [100, 49],
    // Alias of `bgBlackBright`
    bgGrey: [100, 49],
    // Alias of `bgBlackBright`
    bgRedBright: [101, 49],
    bgGreenBright: [102, 49],
    bgYellowBright: [103, 49],
    bgBlueBright: [104, 49],
    bgMagentaBright: [105, 49],
    bgCyanBright: [106, 49],
    bgWhiteBright: [107, 49]
  }
};
function assembleStyles() {
  const codes = /* @__PURE__ */ new Map();
  for (const [groupName, group] of Object.entries(styles$1)) {
    for (const [styleName, style] of Object.entries(group)) {
      styles$1[styleName] = {
        open: `\x1B[${style[0]}m`,
        close: `\x1B[${style[1]}m`
      };
      group[styleName] = styles$1[styleName];
      codes.set(style[0], style[1]);
    }
    Object.defineProperty(styles$1, groupName, {
      value: group,
      enumerable: false
    });
  }
  Object.defineProperty(styles$1, "codes", {
    value: codes,
    enumerable: false
  });
  styles$1.color.close = "\x1B[39m";
  styles$1.bgColor.close = "\x1B[49m";
  styles$1.color.ansi = wrapAnsi16();
  styles$1.color.ansi256 = wrapAnsi256();
  styles$1.color.ansi16m = wrapAnsi16m();
  styles$1.bgColor.ansi = wrapAnsi16(ANSI_BACKGROUND_OFFSET);
  styles$1.bgColor.ansi256 = wrapAnsi256(ANSI_BACKGROUND_OFFSET);
  styles$1.bgColor.ansi16m = wrapAnsi16m(ANSI_BACKGROUND_OFFSET);
  Object.defineProperties(styles$1, {
    rgbToAnsi256: {
      value(red, green, blue) {
        if (red === green && green === blue) {
          if (red < 8) {
            return 16;
          }
          if (red > 248) {
            return 231;
          }
          return Math.round((red - 8) / 247 * 24) + 232;
        }
        return 16 + 36 * Math.round(red / 255 * 5) + 6 * Math.round(green / 255 * 5) + Math.round(blue / 255 * 5);
      },
      enumerable: false
    },
    hexToRgb: {
      value(hex) {
        const matches = /[a-f\d]{6}|[a-f\d]{3}/i.exec(hex.toString(16));
        if (!matches) {
          return [0, 0, 0];
        }
        let [colorString] = matches;
        if (colorString.length === 3) {
          colorString = [...colorString].map((character) => character + character).join("");
        }
        const integer = Number.parseInt(colorString, 16);
        return [
          /* eslint-disable no-bitwise */
          integer >> 16 & 255,
          integer >> 8 & 255,
          integer & 255
          /* eslint-enable no-bitwise */
        ];
      },
      enumerable: false
    },
    hexToAnsi256: {
      value: (hex) => styles$1.rgbToAnsi256(...styles$1.hexToRgb(hex)),
      enumerable: false
    },
    ansi256ToAnsi: {
      value(code) {
        if (code < 8) {
          return 30 + code;
        }
        if (code < 16) {
          return 90 + (code - 8);
        }
        let red;
        let green;
        let blue;
        if (code >= 232) {
          red = ((code - 232) * 10 + 8) / 255;
          green = red;
          blue = red;
        } else {
          code -= 16;
          const remainder = code % 36;
          red = Math.floor(code / 36) / 5;
          green = Math.floor(remainder / 6) / 5;
          blue = remainder % 6 / 5;
        }
        const value = Math.max(red, green, blue) * 2;
        if (value === 0) {
          return 30;
        }
        let result = 30 + (Math.round(blue) << 2 | Math.round(green) << 1 | Math.round(red));
        if (value === 2) {
          result += 60;
        }
        return result;
      },
      enumerable: false
    },
    rgbToAnsi: {
      value: (red, green, blue) => styles$1.ansi256ToAnsi(styles$1.rgbToAnsi256(red, green, blue)),
      enumerable: false
    },
    hexToAnsi: {
      value: (hex) => styles$1.ansi256ToAnsi(styles$1.hexToAnsi256(hex)),
      enumerable: false
    }
  });
  return styles$1;
}
const ansiStyles = assembleStyles();
const level = (() => {
  if (navigator.userAgentData) {
    const brand = navigator.userAgentData.brands.find(({ brand: brand2 }) => brand2 === "Chromium");
    if (brand && brand.version > 93) {
      return 3;
    }
  }
  if (/\b(Chrome|Chromium)\//.test(navigator.userAgent)) {
    return 1;
  }
  return 0;
})();
const colorSupport = level !== 0 && {
  level,
  hasBasic: true,
  has256: level >= 2,
  has16m: level >= 3
};
const supportsColor = {
  stdout: colorSupport,
  stderr: colorSupport
};
function stringReplaceAll(string, substring, replacer) {
  let index = string.indexOf(substring);
  if (index === -1) {
    return string;
  }
  const substringLength = substring.length;
  let endIndex = 0;
  let returnValue = "";
  do {
    returnValue += string.slice(endIndex, index) + substring + replacer;
    endIndex = index + substringLength;
    index = string.indexOf(substring, endIndex);
  } while (index !== -1);
  returnValue += string.slice(endIndex);
  return returnValue;
}
function stringEncaseCRLFWithFirstIndex(string, prefix, postfix, index) {
  let endIndex = 0;
  let returnValue = "";
  do {
    const gotCR = string[index - 1] === "\r";
    returnValue += string.slice(endIndex, gotCR ? index - 1 : index) + prefix + (gotCR ? "\r\n" : "\n") + postfix;
    endIndex = index + 1;
    index = string.indexOf("\n", endIndex);
  } while (index !== -1);
  returnValue += string.slice(endIndex);
  return returnValue;
}
const { stdout: stdoutColor, stderr: stderrColor } = supportsColor;
const GENERATOR = Symbol("GENERATOR");
const STYLER = Symbol("STYLER");
const IS_EMPTY = Symbol("IS_EMPTY");
const levelMapping = [
  "ansi",
  "ansi",
  "ansi256",
  "ansi16m"
];
const styles = /* @__PURE__ */ Object.create(null);
const applyOptions = (object, options = {}) => {
  if (options.level && !(Number.isInteger(options.level) && options.level >= 0 && options.level <= 3)) {
    throw new Error("The `level` option should be an integer from 0 to 3");
  }
  const colorLevel = stdoutColor ? stdoutColor.level : 0;
  object.level = options.level === void 0 ? colorLevel : options.level;
};
const chalkFactory = (options) => {
  const chalk2 = (...strings) => strings.join(" ");
  applyOptions(chalk2, options);
  Object.setPrototypeOf(chalk2, createChalk.prototype);
  return chalk2;
};
function createChalk(options) {
  return chalkFactory(options);
}
Object.setPrototypeOf(createChalk.prototype, Function.prototype);
for (const [styleName, style] of Object.entries(ansiStyles)) {
  styles[styleName] = {
    get() {
      const builder = createBuilder(this, createStyler(style.open, style.close, this[STYLER]), this[IS_EMPTY]);
      Object.defineProperty(this, styleName, { value: builder });
      return builder;
    }
  };
}
styles.visible = {
  get() {
    const builder = createBuilder(this, this[STYLER], true);
    Object.defineProperty(this, "visible", { value: builder });
    return builder;
  }
};
const getModelAnsi = (model, level2, type, ...arguments_) => {
  if (model === "rgb") {
    if (level2 === "ansi16m") {
      return ansiStyles[type].ansi16m(...arguments_);
    }
    if (level2 === "ansi256") {
      return ansiStyles[type].ansi256(ansiStyles.rgbToAnsi256(...arguments_));
    }
    return ansiStyles[type].ansi(ansiStyles.rgbToAnsi(...arguments_));
  }
  if (model === "hex") {
    return getModelAnsi("rgb", level2, type, ...ansiStyles.hexToRgb(...arguments_));
  }
  return ansiStyles[type][model](...arguments_);
};
const usedModels = ["rgb", "hex", "ansi256"];
for (const model of usedModels) {
  styles[model] = {
    get() {
      const { level: level2 } = this;
      return function(...arguments_) {
        const styler = createStyler(getModelAnsi(model, levelMapping[level2], "color", ...arguments_), ansiStyles.color.close, this[STYLER]);
        return createBuilder(this, styler, this[IS_EMPTY]);
      };
    }
  };
  const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
  styles[bgModel] = {
    get() {
      const { level: level2 } = this;
      return function(...arguments_) {
        const styler = createStyler(getModelAnsi(model, levelMapping[level2], "bgColor", ...arguments_), ansiStyles.bgColor.close, this[STYLER]);
        return createBuilder(this, styler, this[IS_EMPTY]);
      };
    }
  };
}
const proto = Object.defineProperties(() => {
}, {
  ...styles,
  level: {
    enumerable: true,
    get() {
      return this[GENERATOR].level;
    },
    set(level2) {
      this[GENERATOR].level = level2;
    }
  }
});
const createStyler = (open, close, parent) => {
  let openAll;
  let closeAll;
  if (parent === void 0) {
    openAll = open;
    closeAll = close;
  } else {
    openAll = parent.openAll + open;
    closeAll = close + parent.closeAll;
  }
  return {
    open,
    close,
    openAll,
    closeAll,
    parent
  };
};
const createBuilder = (self, _styler, _isEmpty) => {
  const builder = (...arguments_) => applyStyle(builder, arguments_.length === 1 ? "" + arguments_[0] : arguments_.join(" "));
  Object.setPrototypeOf(builder, proto);
  builder[GENERATOR] = self;
  builder[STYLER] = _styler;
  builder[IS_EMPTY] = _isEmpty;
  return builder;
};
const applyStyle = (self, string) => {
  if (self.level <= 0 || !string) {
    return self[IS_EMPTY] ? "" : string;
  }
  let styler = self[STYLER];
  if (styler === void 0) {
    return string;
  }
  const { openAll, closeAll } = styler;
  if (string.includes("\x1B")) {
    while (styler !== void 0) {
      string = stringReplaceAll(string, styler.close, styler.open);
      styler = styler.parent;
    }
  }
  const lfIndex = string.indexOf("\n");
  if (lfIndex !== -1) {
    string = stringEncaseCRLFWithFirstIndex(string, closeAll, openAll, lfIndex);
  }
  return openAll + string + closeAll;
};
Object.defineProperties(createChalk.prototype, styles);
const chalk = createChalk();
createChalk({ level: stderrColor ? stderrColor.level : 0 });
const chalk$1 = chalk;
var LogLevel = /* @__PURE__ */ ((LogLevel2) => {
  LogLevel2[LogLevel2["ERROR"] = 0] = "ERROR";
  LogLevel2[LogLevel2["WARN"] = 1] = "WARN";
  LogLevel2[LogLevel2["INFO"] = 2] = "INFO";
  LogLevel2[LogLevel2["DEBUG"] = 3] = "DEBUG";
  LogLevel2[LogLevel2["TRACE"] = 4] = "TRACE";
  return LogLevel2;
})(LogLevel || {});
const optionsSchema$1 = objectType({
  core: custom(),
  level: nativeEnumType(LogLevel).default(
    2
    /* INFO */
  ),
  prefix: stringType().optional()
});
const extendSchema = optionsSchema$1.pick({
  prefix: true
});
const WORKGRID = chalk$1.level ? chalk$1.bgHex("#002dc2").white(" workgrid ") : "workgrid";
class Logger {
  constructor(options) {
    __publicField(this, "options");
    __publicField(this, "core");
    __publicField(this, "level");
    __publicField(this, "prefix");
    this.options = optionsSchema$1.parse(options);
    this.core = this.options.core;
    this.level = this.options.level;
    this.prefix = this.options.prefix;
  }
  error(...args) {
    if (this.level < 0)
      return;
    const message = [WORKGRID, this.prefix, typeof args[0] === "string" ? args[0] : null].filter(Boolean).join(" ");
    console.error(...typeof args[0] === "string" ? [message, ...args.slice(1)] : [message, ...args]);
  }
  warn(...args) {
    if (this.level < 1)
      return;
    const message = [WORKGRID, this.prefix, typeof args[0] === "string" ? args[0] : null].filter(Boolean).join(" ");
    console.warn(...typeof args[0] === "string" ? [message, ...args.slice(1)] : [message, ...args]);
  }
  info(...args) {
    if (this.level < 2)
      return;
    const message = [WORKGRID, this.prefix, typeof args[0] === "string" ? args[0] : null].filter(Boolean).join(" ");
    console.info(...typeof args[0] === "string" ? [message, ...args.slice(1)] : [message, ...args]);
  }
  debug(...args) {
    if (this.level < 3)
      return;
    const message = [WORKGRID, this.prefix, typeof args[0] === "string" ? args[0] : null].filter(Boolean).join(" ");
    console.debug(...typeof args[0] === "string" ? [message, ...args.slice(1)] : [message, ...args]);
  }
  trace(...args) {
    if (this.level < 4)
      return;
    const message = [WORKGRID, this.prefix, typeof args[0] === "string" ? args[0] : null].filter(Boolean).join(" ");
    console.trace(...typeof args[0] === "string" ? [message, ...args.slice(1)] : [message, ...args]);
  }
  wrapFn(...args) {
    const [method, callback] = args.length === 2 ? args : [args[0].name.replace(/^bound /, ""), args[0]];
    return (...args2) => {
      this.debug("→", `${method}()`, ...args2);
      const result = callback(...args2);
      this.debug("←", `${method}()`, result);
      return result;
    };
  }
  extend(options) {
    const resolvedOptions = extendSchema.parse(options);
    return new this.constructor({ core: this.core, level: this.level, ...resolvedOptions });
  }
}
class HTTPError extends Error {
  constructor(response, request, options) {
    const code = response.status || response.status === 0 ? response.status : "";
    const title = response.statusText || "";
    const status = `${code} ${title}`.trim();
    const reason = status ? `status code ${status}` : "an unknown error";
    super(`Request failed with ${reason}`);
    Object.defineProperty(this, "response", {
      enumerable: true,
      configurable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "request", {
      enumerable: true,
      configurable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "options", {
      enumerable: true,
      configurable: true,
      writable: true,
      value: void 0
    });
    this.name = "HTTPError";
    this.response = response;
    this.request = request;
    this.options = options;
  }
}
class TimeoutError extends Error {
  constructor(request) {
    super("Request timed out");
    Object.defineProperty(this, "request", {
      enumerable: true,
      configurable: true,
      writable: true,
      value: void 0
    });
    this.name = "TimeoutError";
    this.request = request;
  }
}
const isObject = (value) => value !== null && typeof value === "object";
const validateAndMerge = (...sources) => {
  for (const source of sources) {
    if ((!isObject(source) || Array.isArray(source)) && typeof source !== "undefined") {
      throw new TypeError("The `options` argument must be an object");
    }
  }
  return deepMerge({}, ...sources);
};
const mergeHeaders = (source1 = {}, source2 = {}) => {
  const result = new globalThis.Headers(source1);
  const isHeadersInstance = source2 instanceof globalThis.Headers;
  const source = new globalThis.Headers(source2);
  for (const [key, value] of source.entries()) {
    if (isHeadersInstance && value === "undefined" || value === void 0) {
      result.delete(key);
    } else {
      result.set(key, value);
    }
  }
  return result;
};
const deepMerge = (...sources) => {
  let returnValue = {};
  let headers = {};
  for (const source of sources) {
    if (Array.isArray(source)) {
      if (!Array.isArray(returnValue)) {
        returnValue = [];
      }
      returnValue = [...returnValue, ...source];
    } else if (isObject(source)) {
      for (let [key, value] of Object.entries(source)) {
        if (isObject(value) && key in returnValue) {
          value = deepMerge(returnValue[key], value);
        }
        returnValue = { ...returnValue, [key]: value };
      }
      if (isObject(source.headers)) {
        headers = mergeHeaders(headers, source.headers);
        returnValue.headers = headers;
      }
    }
  }
  return returnValue;
};
const supportsRequestStreams = (() => {
  let duplexAccessed = false;
  let hasContentType = false;
  const supportsReadableStream = typeof globalThis.ReadableStream === "function";
  const supportsRequest = typeof globalThis.Request === "function";
  if (supportsReadableStream && supportsRequest) {
    hasContentType = new globalThis.Request("https://a.com", {
      body: new globalThis.ReadableStream(),
      method: "POST",
      // @ts-expect-error - Types are outdated.
      get duplex() {
        duplexAccessed = true;
        return "half";
      }
    }).headers.has("Content-Type");
  }
  return duplexAccessed && !hasContentType;
})();
const supportsAbortController = typeof globalThis.AbortController === "function";
const supportsResponseStreams = typeof globalThis.ReadableStream === "function";
const supportsFormData = typeof globalThis.FormData === "function";
const requestMethods = ["get", "post", "put", "patch", "head", "delete"];
const responseTypes = {
  json: "application/json",
  text: "text/*",
  formData: "multipart/form-data",
  arrayBuffer: "*/*",
  blob: "*/*"
};
const maxSafeTimeout = 2147483647;
const stop = Symbol("stop");
const normalizeRequestMethod = (input) => requestMethods.includes(input) ? input.toUpperCase() : input;
const retryMethods = ["get", "put", "head", "delete", "options", "trace"];
const retryStatusCodes = [408, 413, 429, 500, 502, 503, 504];
const retryAfterStatusCodes = [413, 429, 503];
const defaultRetryOptions = {
  limit: 2,
  methods: retryMethods,
  statusCodes: retryStatusCodes,
  afterStatusCodes: retryAfterStatusCodes,
  maxRetryAfter: Number.POSITIVE_INFINITY,
  backoffLimit: Number.POSITIVE_INFINITY
};
const normalizeRetryOptions = (retry = {}) => {
  if (typeof retry === "number") {
    return {
      ...defaultRetryOptions,
      limit: retry
    };
  }
  if (retry.methods && !Array.isArray(retry.methods)) {
    throw new Error("retry.methods must be an array");
  }
  if (retry.statusCodes && !Array.isArray(retry.statusCodes)) {
    throw new Error("retry.statusCodes must be an array");
  }
  return {
    ...defaultRetryOptions,
    ...retry,
    afterStatusCodes: retryAfterStatusCodes
  };
};
async function timeout(request, abortController, options) {
  return new Promise((resolve, reject) => {
    const timeoutId = setTimeout(() => {
      if (abortController) {
        abortController.abort();
      }
      reject(new TimeoutError(request));
    }, options.timeout);
    void options.fetch(request).then(resolve).catch(reject).then(() => {
      clearTimeout(timeoutId);
    });
  });
}
const isDomExceptionSupported = Boolean(globalThis.DOMException);
function composeAbortError(signal) {
  if (isDomExceptionSupported) {
    return new DOMException((signal == null ? void 0 : signal.reason) ?? "The operation was aborted.", "AbortError");
  }
  const error = new Error((signal == null ? void 0 : signal.reason) ?? "The operation was aborted.");
  error.name = "AbortError";
  return error;
}
async function delay(ms, { signal }) {
  return new Promise((resolve, reject) => {
    if (signal) {
      if (signal.aborted) {
        reject(composeAbortError(signal));
        return;
      }
      signal.addEventListener("abort", handleAbort, { once: true });
    }
    function handleAbort() {
      reject(composeAbortError(signal));
      clearTimeout(timeoutId);
    }
    const timeoutId = setTimeout(() => {
      signal == null ? void 0 : signal.removeEventListener("abort", handleAbort);
      resolve();
    }, ms);
  });
}
class Ky {
  // eslint-disable-next-line @typescript-eslint/promise-function-async
  static create(input, options) {
    const ky2 = new Ky(input, options);
    const fn = async () => {
      if (ky2._options.timeout > maxSafeTimeout) {
        throw new RangeError(`The \`timeout\` option cannot be greater than ${maxSafeTimeout}`);
      }
      await Promise.resolve();
      let response = await ky2._fetch();
      for (const hook of ky2._options.hooks.afterResponse) {
        const modifiedResponse = await hook(ky2.request, ky2._options, ky2._decorateResponse(response.clone()));
        if (modifiedResponse instanceof globalThis.Response) {
          response = modifiedResponse;
        }
      }
      ky2._decorateResponse(response);
      if (!response.ok && ky2._options.throwHttpErrors) {
        let error = new HTTPError(response, ky2.request, ky2._options);
        for (const hook of ky2._options.hooks.beforeError) {
          error = await hook(error);
        }
        throw error;
      }
      if (ky2._options.onDownloadProgress) {
        if (typeof ky2._options.onDownloadProgress !== "function") {
          throw new TypeError("The `onDownloadProgress` option must be a function");
        }
        if (!supportsResponseStreams) {
          throw new Error("Streams are not supported in your environment. `ReadableStream` is missing.");
        }
        return ky2._stream(response.clone(), ky2._options.onDownloadProgress);
      }
      return response;
    };
    const isRetriableMethod = ky2._options.retry.methods.includes(ky2.request.method.toLowerCase());
    const result = isRetriableMethod ? ky2._retry(fn) : fn();
    for (const [type, mimeType] of Object.entries(responseTypes)) {
      result[type] = async () => {
        ky2.request.headers.set("accept", ky2.request.headers.get("accept") || mimeType);
        const awaitedResult = await result;
        const response = awaitedResult.clone();
        if (type === "json") {
          if (response.status === 204) {
            return "";
          }
          const arrayBuffer = await response.clone().arrayBuffer();
          const responseSize = arrayBuffer.byteLength;
          if (responseSize === 0) {
            return "";
          }
          if (options.parseJson) {
            return options.parseJson(await response.text());
          }
        }
        return response[type]();
      };
    }
    return result;
  }
  // eslint-disable-next-line complexity
  constructor(input, options = {}) {
    Object.defineProperty(this, "request", {
      enumerable: true,
      configurable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "abortController", {
      enumerable: true,
      configurable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "_retryCount", {
      enumerable: true,
      configurable: true,
      writable: true,
      value: 0
    });
    Object.defineProperty(this, "_input", {
      enumerable: true,
      configurable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "_options", {
      enumerable: true,
      configurable: true,
      writable: true,
      value: void 0
    });
    this._input = input;
    this._options = {
      // TODO: credentials can be removed when the spec change is implemented in all browsers. Context: https://www.chromestatus.com/feature/4539473312350208
      credentials: this._input.credentials || "same-origin",
      ...options,
      headers: mergeHeaders(this._input.headers, options.headers),
      hooks: deepMerge({
        beforeRequest: [],
        beforeRetry: [],
        beforeError: [],
        afterResponse: []
      }, options.hooks),
      method: normalizeRequestMethod(options.method ?? this._input.method),
      // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
      prefixUrl: String(options.prefixUrl || ""),
      retry: normalizeRetryOptions(options.retry),
      throwHttpErrors: options.throwHttpErrors !== false,
      timeout: typeof options.timeout === "undefined" ? 1e4 : options.timeout,
      fetch: options.fetch ?? globalThis.fetch.bind(globalThis)
    };
    if (typeof this._input !== "string" && !(this._input instanceof URL || this._input instanceof globalThis.Request)) {
      throw new TypeError("`input` must be a string, URL, or Request");
    }
    if (this._options.prefixUrl && typeof this._input === "string") {
      if (this._input.startsWith("/")) {
        throw new Error("`input` must not begin with a slash when using `prefixUrl`");
      }
      if (!this._options.prefixUrl.endsWith("/")) {
        this._options.prefixUrl += "/";
      }
      this._input = this._options.prefixUrl + this._input;
    }
    if (supportsAbortController) {
      this.abortController = new globalThis.AbortController();
      if (this._options.signal) {
        const originalSignal = this._options.signal;
        this._options.signal.addEventListener("abort", () => {
          this.abortController.abort(originalSignal.reason);
        });
      }
      this._options.signal = this.abortController.signal;
    }
    if (supportsRequestStreams) {
      this._options.duplex = "half";
    }
    this.request = new globalThis.Request(this._input, this._options);
    if (this._options.searchParams) {
      const textSearchParams = typeof this._options.searchParams === "string" ? this._options.searchParams.replace(/^\?/, "") : new URLSearchParams(this._options.searchParams).toString();
      const searchParams = "?" + textSearchParams;
      const url = this.request.url.replace(/(?:\?.*?)?(?=#|$)/, searchParams);
      if ((supportsFormData && this._options.body instanceof globalThis.FormData || this._options.body instanceof URLSearchParams) && !(this._options.headers && this._options.headers["content-type"])) {
        this.request.headers.delete("content-type");
      }
      this.request = new globalThis.Request(new globalThis.Request(url, { ...this.request }), this._options);
    }
    if (this._options.json !== void 0) {
      this._options.body = JSON.stringify(this._options.json);
      this.request.headers.set("content-type", this._options.headers.get("content-type") ?? "application/json");
      this.request = new globalThis.Request(this.request, { body: this._options.body });
    }
  }
  _calculateRetryDelay(error) {
    this._retryCount++;
    if (this._retryCount < this._options.retry.limit && !(error instanceof TimeoutError)) {
      if (error instanceof HTTPError) {
        if (!this._options.retry.statusCodes.includes(error.response.status)) {
          return 0;
        }
        const retryAfter = error.response.headers.get("Retry-After");
        if (retryAfter && this._options.retry.afterStatusCodes.includes(error.response.status)) {
          let after = Number(retryAfter);
          if (Number.isNaN(after)) {
            after = Date.parse(retryAfter) - Date.now();
          } else {
            after *= 1e3;
          }
          if (typeof this._options.retry.maxRetryAfter !== "undefined" && after > this._options.retry.maxRetryAfter) {
            return 0;
          }
          return after;
        }
        if (error.response.status === 413) {
          return 0;
        }
      }
      const BACKOFF_FACTOR = 0.3;
      return Math.min(this._options.retry.backoffLimit, BACKOFF_FACTOR * 2 ** (this._retryCount - 1) * 1e3);
    }
    return 0;
  }
  _decorateResponse(response) {
    if (this._options.parseJson) {
      response.json = async () => this._options.parseJson(await response.text());
    }
    return response;
  }
  async _retry(fn) {
    try {
      return await fn();
    } catch (error) {
      const ms = Math.min(this._calculateRetryDelay(error), maxSafeTimeout);
      if (ms !== 0 && this._retryCount > 0) {
        await delay(ms, { signal: this._options.signal });
        for (const hook of this._options.hooks.beforeRetry) {
          const hookResult = await hook({
            request: this.request,
            options: this._options,
            error,
            retryCount: this._retryCount
          });
          if (hookResult === stop) {
            return;
          }
        }
        return this._retry(fn);
      }
      throw error;
    }
  }
  async _fetch() {
    for (const hook of this._options.hooks.beforeRequest) {
      const result = await hook(this.request, this._options);
      if (result instanceof Request) {
        this.request = result;
        break;
      }
      if (result instanceof Response) {
        return result;
      }
    }
    if (this._options.timeout === false) {
      return this._options.fetch(this.request.clone());
    }
    return timeout(this.request.clone(), this.abortController, this._options);
  }
  /* istanbul ignore next */
  _stream(response, onDownloadProgress) {
    const totalBytes = Number(response.headers.get("content-length")) || 0;
    let transferredBytes = 0;
    if (response.status === 204) {
      if (onDownloadProgress) {
        onDownloadProgress({ percent: 1, totalBytes, transferredBytes }, new Uint8Array());
      }
      return new globalThis.Response(null, {
        status: response.status,
        statusText: response.statusText,
        headers: response.headers
      });
    }
    return new globalThis.Response(new globalThis.ReadableStream({
      async start(controller) {
        const reader = response.body.getReader();
        if (onDownloadProgress) {
          onDownloadProgress({ percent: 0, transferredBytes: 0, totalBytes }, new Uint8Array());
        }
        async function read() {
          const { done, value } = await reader.read();
          if (done) {
            controller.close();
            return;
          }
          if (onDownloadProgress) {
            transferredBytes += value.byteLength;
            const percent = totalBytes === 0 ? 0 : transferredBytes / totalBytes;
            onDownloadProgress({ percent, transferredBytes, totalBytes }, value);
          }
          controller.enqueue(value);
          await read();
        }
        await read();
      }
    }), {
      status: response.status,
      statusText: response.statusText,
      headers: response.headers
    });
  }
}
/*! MIT License © Sindre Sorhus */
const createInstance = (defaults) => {
  const ky2 = (input, options) => Ky.create(input, validateAndMerge(defaults, options));
  for (const method of requestMethods) {
    ky2[method] = (input, options) => Ky.create(input, validateAndMerge(defaults, options, { method }));
  }
  ky2.create = (newDefaults) => createInstance(validateAndMerge(newDefaults));
  ky2.extend = (newDefaults) => createInstance(validateAndMerge(defaults, newDefaults));
  ky2.stop = stop;
  return ky2;
};
const ky = createInstance();
const ky$1 = ky;
const optionsSchema = objectType({
  core: custom()
});
class Network {
  constructor(options) {
    __publicField(this, "options");
    __publicField(this, "core");
    __publicField(this, "logger");
    this.options = optionsSchema.parse(options);
    this.core = this.options.core;
    this.logger = this.options.core.logger.extend({ prefix: "core/network" });
    this.request = this.logger.wrapFn(this.request.bind(this));
  }
  async request(url, options) {
    const prefixUrl = await this.core.getApiHost();
    return ky$1(url, { timeout: false, prefixUrl, ...options });
  }
  get(url, options) {
    return this.request(url, {
      method: "get",
      ...options
    });
  }
  post(url, options) {
    return this.request(url, {
      method: "post",
      ...options
    });
  }
  put(url, options) {
    return this.request(url, {
      method: "put",
      ...options
    });
  }
  patch(url, options) {
    return this.request(url, {
      method: "patch",
      ...options
    });
  }
  delete(url, options) {
    return this.request(url, {
      method: "delete",
      ...options
    });
  }
}
class Core {
  constructor(options) {
    __publicField(this, "options");
    __publicField(this, "cache");
    __publicField(this, "logger");
    __publicField(this, "network");
    this.options = optionsSchema$3.parse(options);
    const logger = this.options.logger ?? new Logger({ core: this, level: 4 });
    this.logger = logger.extend({ prefix: "core" });
    this.cache = this.options.cache ?? new Cache({ core: this });
    this.network = this.options.network ?? new Network({ core: this });
    this.getToken = jwtCache({ getToken: this.logger.wrapFn(this.getToken.bind(this)) }).getToken;
    this.getApiHost = pMemoize(this.logger.wrapFn(this.getApiHost.bind(this)));
    this.getConfig = pMemoize(this.logger.wrapFn(this.getConfig.bind(this)));
    this.getUser = pMemoize(this.logger.wrapFn(this.getUser.bind(this)));
  }
  /**
   * Resolve a user token
   */
  async getToken() {
    let token = await this.options.getToken(this);
    if (token instanceof Response) {
      token = await token.text();
    }
    return token;
  }
  /**
   * Resolve the api host
   */
  async getApiHost() {
    return this.options.getApiHost(this);
  }
  /**
   * Fetch the client config
   */
  async getConfig() {
    const cacheKey = `config/${this.options.key ?? "DEFAULT"}`;
    const promise = (async () => {
      const token = await this.getToken();
      const response = await this.network.get("v1/admin/client-config", {
        headers: {
          Authorization: `Bearer ${token}`
        },
        searchParams: {
          key: this.options.key ?? ""
        }
      });
      const config2 = getConfigResponseSchema.parse(await response.json());
      this.cache.set(cacheKey, config2);
      return config2;
    })();
    let config = this.cache.get(cacheKey);
    if (!config)
      config = await promise;
    return configSchema.parse(config);
  }
  /**
   * Fetch the current user
   */
  async getUser() {
    const token = await this.getToken();
    const { sub } = objectType({ sub: stringType() }).parse(o(token));
    const cacheKey = `user/${sub}`;
    const promise = (async () => {
      const token2 = await this.getToken();
      const response = await this.network.get("v1/admin/user", {
        headers: {
          Authorization: `Bearer ${token2}`
        }
      });
      const user2 = getUserResponseSchema.parse(await response.json());
      this.cache.set(cacheKey, user2);
      return user2;
    })();
    let user = this.cache.get(cacheKey);
    if (!user)
      user = await promise;
    return userSchema.parse(user);
  }
  /**
   * Fetch a microapp view
   */
  async getView(options) {
    const resolvedOptions = getViewInputSchema.parse(options);
    const token = await this.getToken();
    const response = await this.network.post(`v1/appbuilder/userapps/${resolvedOptions.endpoint}`, {
      headers: {
        Authorization: `Bearer ${token}`,
        "x-workgrid-space": resolvedOptions.spaceId
      },
      json: { data: resolvedOptions.data }
    });
    let data = getViewResponseSchema.parse(await response.json());
    data = injectActionData(data, {
      spaceId: resolvedOptions.spaceId
    });
    return data;
  }
  /**
   * Prompt the ask api
   */
  async ask(options) {
    const resolvedOptions = askInputSchema.parse(options);
    const token = await this.getToken();
    const response = await this.network.post("v2/ask", {
      headers: {
        Authorization: `Bearer ${token}`,
        "x-workgrid-space": resolvedOptions.spaceId
      },
      json: {
        locale: "en_US",
        channel: "unified",
        utterance: resolvedOptions.message,
        ...resolvedOptions.botId ? {
          botId: resolvedOptions.botId,
          botAliasId: resolvedOptions.botAliasId,
          appId: resolvedOptions.appId
        } : {}
      }
    });
    let data = askResponseSchema.parse(await response.json());
    if ("view" in data) {
      data = {
        ...data,
        view: injectActionData(data.view, {
          spaceId: resolvedOptions.spaceId
        })
      };
    }
    if ("notifications" in data) {
      data = {
        ...data,
        notifications: data.notifications.map((notification) => ({
          ...notification,
          view: injectActionData(notification.view, {
            spaceId: resolvedOptions.spaceId,
            notificationId: notification.metadata.id
          })
        }))
      };
    }
    return data;
  }
  /**
   * Action a notification
   */
  async actionNotification(options) {
    const resolvedOptions = actionNotificationInputSchema.parse(options);
    const token = await this.getToken();
    const { data, analytics, ...rest } = resolvedOptions.data;
    const response = await this.network.post(`v1/usernotifications/${resolvedOptions.notificationId}/action`, {
      headers: {
        Authorization: `Bearer ${token}`,
        "x-workgrid-space": resolvedOptions.spaceId
      },
      json: {
        data: { ...rest, ...data },
        analytics
      }
    });
    return actionNotificationResponseSchema.parse(await response.json());
  }
}
function injectActionData(view, data) {
  return traverse$1(view).map((node) => {
    if (node.type === "Action.Execute" || node.type == "Action.Submit") {
      if (!("data" in node && typeof node.data === "object"))
        return;
      return { ...node, data: { ...node.data, __internal__: data } };
    }
  });
}
export {
  actionNotificationInputSchema,
  actionNotificationResponseSchema,
  askInputSchema,
  askResponseSchema,
  configSchema,
  Core as default,
  getConfigResponseSchema,
  getUserResponseSchema,
  getViewInputSchema,
  getViewResponseSchema,
  optionsSchema$3 as optionsSchema,
  userSchema
};
//# sourceMappingURL=index-0f074b43.js.map
